/*****************************************************************************
 * 256 bytes tech-tech fun
 * code: cruzer/cml
 * asm: kickass 2.0 beta 2
 * tab: 4 chars
 *****************************************************************************/

//-----------------------------------------------------------------------------
// memory
//-----------------------------------------------------------------------------

.var x =			$0a
.var y =			$0b
.var dis =			$0c
.var cnt =			$0d
.var p0 =			$10
.var tmp =          $ff
.var code =			$0801
.var sine128 =		$1000
.var screens =		$4000
.var bitmap =       $6000
.var d011s =		$c000
.var d016s =		$c100
.var d018s =		$c200

.pc = code "code"

.var offset = screens + 9 + 4*40

//-----------------------------------------------------------------------------
// basic
//-----------------------------------------------------------------------------

			.byte $0b,$08,$39,$05,$9e,$32,$30,$37,$36
			.byte $00,$00

//-----------------------------------------------------------------------------
// colors
//-----------------------------------------------------------------------------

colors:
			.byte $00 // basic end byte too
			
			//.byte $90,$80,$99,$b9,$b2,$8b,$ab,$c8,$ca,$fa,$ff,$f7,$f1,$71,$11
			//.byte $60,$66,$6b,$64,$b4,$44,$4c,$4a,$aa,$af,$a7,$f7,$77,$71,$11
			//.byte $40,$69,$6b,$64,$6c,$be,$4e,$ec,$4f,$ef,$ff,$f7,$f1,$71,$11
			.byte $90,$99,$92,$22,$28,$88,$8c,$c5,$55,$53,$5d,$3d,$dd,$d1,$11

//-----------------------------------------------------------------------------
// code
//-----------------------------------------------------------------------------

			sei
			
			lda #0 
			pha
			tax


//fill screens...
			
			ldy #$ff
			tya
			sta $d020
!:
!ss:		sta screens,x
			inx
			bne !-
			inc !ss- +2
			bpl !-


//fill bitmap...
			
			//ldx #0
			lda #%01010101
!:
			eor #%11111111
!sbm:		sta bitmap,x
			inx
			bne !-
			inc !sbm- +2
			bpl !-



//calc sine...

!loop:	
loa:		lda #$15
			adc #$07
			sta loa+1
			bcc !+
			inc hia+1
			clc
!:
lo:			adc #$00
			sta lo+1
			pla
hia:		adc #$00
			pha
			sta sine128,x
			sta sine128,y
			sta $dd00
			eor #$7f
			sta sine128+$80,x
			sta sine128-$80,y
			inx
			dey
			cpx #$40
			bne !loop-
		


//copy sine, make luts...

			ldx #0
!loop:
			lda sine128,x
			sta sine128+$100,x
			
			txa
			and #$07
			sta dis
			ora #$30
			sta d011s,x

			inx
			bne !loop-


//set up colors...
			
			//lda #7
			//sta dis
!disLoop:
			lda dis
			tax
			asl
			asl
			tay
			txa
			adc #<offset
			sta p0+0
			tya
			adc #>offset
			sta p0+1
			
			lda #14
			sta y
!yLoop:
			ldy #15
!xLoop:		
			lda colors,y
!st:		sta (p0),y
			dey
			bpl !xLoop-
			
			lda p0+0
			clc
			adc #40
			sta p0+0
			bcc !+
			inc p0+1
!:			
			dec y
			bpl !yLoop-
			
			dec dis
			bpl !disLoop-
			

mainLoop:

//display...

			lda #$50
!:			cmp $d012
			bne !-

			ldx #0
!:
			lda d011s,x
			sta $d011
			lda d018s,x
			sta $d018
			lda d016s,x
			sta $d016
			inx
			bpl !-
			

//update...
			
			tya
			clc
			adc #$7a
			tay
!:
			lda sine128,y
			sta !as+ +1
!as:		lda sine128
			adc sine128,x
			lsr
			pha
			lsr
			and #$07
			sta d016s,x
			pla
			ora #$08
			sta d018s,x
			iny
			iny
			iny
			dex
			bpl !-
			
			bmi mainLoop

